%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Switch Component
%
% Algebraic Specification 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Component Switch
Sort: {On, Off, Usv}
Variables: Status
Invariant: false => true

Method: Init
Interface: ?InitialStatus
Requires: 
	?InitialStatus=On | ?InitialStatus=Off
Ensures:
?InitialStatus=On ->
   true => Status=On; 
?InitialStatus=Off ->
   true => Status=Off; 

Method: Toggle
Interface: ?InitialStatus	
Requires: 
	?InitialStatus=On | ?InitialStatus=Off
Ensures:
?InitialStatus=On ->
   true => Status=Off; 
?InitialStatus=Off ->
   true => Status=On; 

Method: SetAndDisplay
Interface: !Value, ?InitialStatus
Requires: true
Ensures:
?InitialStatus=On ->
   true => !Value=On,
   true => Status=On; 
?InitialStatus=Off ->
   true => !Value=Off,
   true => Status=Off; 
?InitialStatus=Usv ->
   true => !Value=Usv,
   true => Status=Usv; 

Method: SwitchOff
Interface:  
Requires: Status=On
Ensures:
Status=On ->
	true => Status=Off;

Method: Discontinue
Interface:  
Requires: Status=Off
Ensures:
Status=Off ->
	true => Status=Usv;




